/* Parameter.c generated by valac 0.32.1, the Vala compiler
 * generated from Parameter.vala, do not modify */

/*
 * Parameter.vala
 *
 * Copyright (C) 2014 Stefan Ringel <linuxtv@stefanringel.de>
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gst/gst.h>
#include <stdlib.h>
#include <string.h>


#define DVB_TYPE_PARAMETER (dvb_parameter_get_type ())
#define DVB_PARAMETER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_PARAMETER, DVBParameter))
#define DVB_PARAMETER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_PARAMETER, DVBParameterClass))
#define DVB_IS_PARAMETER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_PARAMETER))
#define DVB_IS_PARAMETER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_PARAMETER))
#define DVB_PARAMETER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_PARAMETER, DVBParameterClass))

typedef struct _DVBParameter DVBParameter;
typedef struct _DVBParameterClass DVBParameterClass;
typedef struct _DVBParameterPrivate DVBParameterPrivate;

#define DVB_TYPE_DVB_SRC_DELSYS (dvb_dvb_src_delsys_get_type ())

struct _DVBParameter {
	GObject parent_instance;
	DVBParameterPrivate * priv;
};

struct _DVBParameterClass {
	GObjectClass parent_class;
	void (*prepare) (DVBParameter* self, GstElement* source);
	gboolean (*add_scanning_data) (DVBParameter* self, GHashTable* data);
	gboolean (*equal) (DVBParameter* self, DVBParameter* param);
	gchar* (*to_string) (DVBParameter* self);
};

typedef enum  {
	DVB_DVB_SRC_DELSYS_SYS_UNDEFINED,
	DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_A,
	DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_B,
	DVB_DVB_SRC_DELSYS_SYS_DVBT,
	DVB_DVB_SRC_DELSYS_SYS_DSS,
	DVB_DVB_SRC_DELSYS_SYS_DVBS,
	DVB_DVB_SRC_DELSYS_SYS_DVBS2,
	DVB_DVB_SRC_DELSYS_SYS_DVBH,
	DVB_DVB_SRC_DELSYS_SYS_ISDBT,
	DVB_DVB_SRC_DELSYS_SYS_ISDBS,
	DVB_DVB_SRC_DELSYS_SYS_ISDBC,
	DVB_DVB_SRC_DELSYS_SYS_ATSC,
	DVB_DVB_SRC_DELSYS_SYS_ATSCMH,
	DVB_DVB_SRC_DELSYS_SYS_DTMB,
	DVB_DVB_SRC_DELSYS_SYS_CMMB,
	DVB_DVB_SRC_DELSYS_SYS_DAB,
	DVB_DVB_SRC_DELSYS_SYS_DVBT2,
	DVB_DVB_SRC_DELSYS_SYS_TURBO,
	DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_C
} DVBDvbSrcDelsys;

struct _DVBParameterPrivate {
	DVBDvbSrcDelsys _Delsys;
	guint _Frequency;
};


static gpointer dvb_parameter_parent_class = NULL;

GType dvb_parameter_get_type (void) G_GNUC_CONST;
GType dvb_dvb_src_delsys_get_type (void) G_GNUC_CONST;
#define DVB_PARAMETER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DVB_TYPE_PARAMETER, DVBParameterPrivate))
enum  {
	DVB_PARAMETER_DUMMY_PROPERTY,
	DVB_PARAMETER_DELSYS,
	DVB_PARAMETER_FREQUENCY
};
DVBParameter* dvb_parameter_construct (GType object_type, DVBDvbSrcDelsys delsys);
void dvb_parameter_prepare (DVBParameter* self, GstElement* source);
static void dvb_parameter_real_prepare (DVBParameter* self, GstElement* source);
gboolean dvb_parameter_add_scanning_data (DVBParameter* self, GHashTable* data);
static gboolean dvb_parameter_real_add_scanning_data (DVBParameter* self, GHashTable* data);
gboolean dvb_parameter_equal (DVBParameter* self, DVBParameter* param);
static gboolean dvb_parameter_real_equal (DVBParameter* self, DVBParameter* param);
gchar* dvb_parameter_to_string (DVBParameter* self);
static gchar* dvb_parameter_real_to_string (DVBParameter* self);
DVBDvbSrcDelsys dvb_parameter_get_Delsys (DVBParameter* self);
static void dvb_parameter_set_Delsys (DVBParameter* self, DVBDvbSrcDelsys value);
guint dvb_parameter_get_Frequency (DVBParameter* self);
void dvb_parameter_set_Frequency (DVBParameter* self, guint value);
static void dvb_parameter_finalize (GObject* obj);
static void _vala_dvb_parameter_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_dvb_parameter_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


DVBParameter* dvb_parameter_construct (GType object_type, DVBDvbSrcDelsys delsys) {
	DVBParameter * self = NULL;
	DVBDvbSrcDelsys _tmp0_ = 0;
	_tmp0_ = delsys;
	self = (DVBParameter*) g_object_new (object_type, "Delsys", _tmp0_, NULL);
	return self;
}


static void dvb_parameter_real_prepare (DVBParameter* self, GstElement* source) {
	g_critical ("Type `%s' does not implement abstract method `dvb_parameter_prepare'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void dvb_parameter_prepare (DVBParameter* self, GstElement* source) {
	g_return_if_fail (self != NULL);
	DVB_PARAMETER_GET_CLASS (self)->prepare (self, source);
}


static gboolean dvb_parameter_real_add_scanning_data (DVBParameter* self, GHashTable* data) {
	g_critical ("Type `%s' does not implement abstract method `dvb_parameter_add_scanning_data'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return FALSE;
}


gboolean dvb_parameter_add_scanning_data (DVBParameter* self, GHashTable* data) {
	g_return_val_if_fail (self != NULL, FALSE);
	return DVB_PARAMETER_GET_CLASS (self)->add_scanning_data (self, data);
}


static gboolean dvb_parameter_real_equal (DVBParameter* self, DVBParameter* param) {
	g_critical ("Type `%s' does not implement abstract method `dvb_parameter_equal'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return FALSE;
}


gboolean dvb_parameter_equal (DVBParameter* self, DVBParameter* param) {
	g_return_val_if_fail (self != NULL, FALSE);
	return DVB_PARAMETER_GET_CLASS (self)->equal (self, param);
}


static gchar* dvb_parameter_real_to_string (DVBParameter* self) {
	g_critical ("Type `%s' does not implement abstract method `dvb_parameter_to_string'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


gchar* dvb_parameter_to_string (DVBParameter* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return DVB_PARAMETER_GET_CLASS (self)->to_string (self);
}


DVBDvbSrcDelsys dvb_parameter_get_Delsys (DVBParameter* self) {
	DVBDvbSrcDelsys result;
	DVBDvbSrcDelsys _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_Delsys;
	result = _tmp0_;
	return result;
}


static void dvb_parameter_set_Delsys (DVBParameter* self, DVBDvbSrcDelsys value) {
	DVBDvbSrcDelsys _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_Delsys = _tmp0_;
	g_object_notify ((GObject *) self, "Delsys");
}


guint dvb_parameter_get_Frequency (DVBParameter* self) {
	guint result;
	guint _tmp0_ = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_Frequency;
	result = _tmp0_;
	return result;
}


void dvb_parameter_set_Frequency (DVBParameter* self, guint value) {
	guint _tmp0_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_Frequency = _tmp0_;
	g_object_notify ((GObject *) self, "Frequency");
}


static void dvb_parameter_class_init (DVBParameterClass * klass) {
	dvb_parameter_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DVBParameterPrivate));
	((DVBParameterClass *) klass)->prepare = dvb_parameter_real_prepare;
	((DVBParameterClass *) klass)->add_scanning_data = dvb_parameter_real_add_scanning_data;
	((DVBParameterClass *) klass)->equal = dvb_parameter_real_equal;
	((DVBParameterClass *) klass)->to_string = dvb_parameter_real_to_string;
	G_OBJECT_CLASS (klass)->get_property = _vala_dvb_parameter_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_dvb_parameter_set_property;
	G_OBJECT_CLASS (klass)->finalize = dvb_parameter_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_PARAMETER_DELSYS, g_param_spec_enum ("Delsys", "Delsys", "Delsys", DVB_TYPE_DVB_SRC_DELSYS, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_PARAMETER_FREQUENCY, g_param_spec_uint ("Frequency", "Frequency", "Frequency", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void dvb_parameter_instance_init (DVBParameter * self) {
	self->priv = DVB_PARAMETER_GET_PRIVATE (self);
}


static void dvb_parameter_finalize (GObject* obj) {
	DVBParameter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_TYPE_PARAMETER, DVBParameter);
	G_OBJECT_CLASS (dvb_parameter_parent_class)->finalize (obj);
}


GType dvb_parameter_get_type (void) {
	static volatile gsize dvb_parameter_type_id__volatile = 0;
	if (g_once_init_enter (&dvb_parameter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DVBParameterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_parameter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBParameter), 0, (GInstanceInitFunc) dvb_parameter_instance_init, NULL };
		GType dvb_parameter_type_id;
		dvb_parameter_type_id = g_type_register_static (G_TYPE_OBJECT, "DVBParameter", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&dvb_parameter_type_id__volatile, dvb_parameter_type_id);
	}
	return dvb_parameter_type_id__volatile;
}


static void _vala_dvb_parameter_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DVBParameter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_TYPE_PARAMETER, DVBParameter);
	switch (property_id) {
		case DVB_PARAMETER_DELSYS:
		g_value_set_enum (value, dvb_parameter_get_Delsys (self));
		break;
		case DVB_PARAMETER_FREQUENCY:
		g_value_set_uint (value, dvb_parameter_get_Frequency (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_dvb_parameter_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DVBParameter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_TYPE_PARAMETER, DVBParameter);
	switch (property_id) {
		case DVB_PARAMETER_DELSYS:
		dvb_parameter_set_Delsys (self, g_value_get_enum (value));
		break;
		case DVB_PARAMETER_FREQUENCY:
		dvb_parameter_set_Frequency (self, g_value_get_uint (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



